(************************************************************************)
(*         *   The Coq Proof Assistant / The Coq Development Team       *)
(*  v      *   INRIA, CNRS and contributors - Copyright 1999-2018       *)
(* <O___,, *       (see CREDITS file for the list of authors)           *)
(*   \VV/  **************************************************************)
(*    //   *    This file is distributed under the terms of the         *)
(*         *     GNU Lesser General Public License Version 2.1          *)
(*         *     (see LICENSE file for the text of the license)         *)
(************************************************************************)

(************************************************************************)
(* Coq serialization API/Plugin                                         *)
(* Copyright 2016-2018 MINES ParisTech -- Dual License LGPL 2.1 / GPL3+ *)
(************************************************************************)
(* Status: Very Experimental                                            *)
(************************************************************************)

open Sexplib

type 'a hint_info_gen = 'a Typeclasses.hint_info_gen

val sexp_of_hint_info_gen : ('a -> Sexp.t) -> 'a hint_info_gen -> Sexp.t
val hint_info_gen_of_sexp : (Sexp.t -> 'a) -> Sexp.t -> 'a hint_info_gen
val hint_info_gen_of_yojson : (Yojson.Safe.t -> ('a, string) Result.result) -> Yojson.Safe.t -> ('a hint_info_gen, string) Result.result
val hint_info_gen_to_yojson : ('a -> Yojson.Safe.t) -> 'a hint_info_gen -> Yojson.Safe.t
